﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_draw_lines
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private List<Segment> Segments = new List<Segment>();
        private Segment NewSegment = null;

        // Start drawing a new segment.
        private void picCanvas_MouseDown(object sender, MouseEventArgs e)
        {
            NewSegment = new Segment(Pens.Blue, e.Location, e.Location);
            picCanvas.Refresh();
        }

        // Continue drawing the new segment.
        private void picCanvas_MouseMove(object sender, MouseEventArgs e)
        {
            if (NewSegment == null) return;
            
            NewSegment.Point2 = e.Location;
            picCanvas.Refresh();
        }

        // Finish drawing the new segment.
        private void picCanvas_MouseUp(object sender, MouseEventArgs e)
        {
            if (NewSegment == null) return;

            NewSegment.Pen = Pens.Black;
            Segments.Add(NewSegment);
            NewSegment = null;
            picCanvas.Refresh();
        }

        // Draw the segments.
        private void picCanvas_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.Clear(picCanvas.BackColor);
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;

            // Draw existing segments.
            foreach (Segment segment in Segments)
                segment.Draw(e.Graphics);

            // Draw the new segment if there is one.
            if (NewSegment != null)
                NewSegment.Draw(e.Graphics);
        }
    }
}
